import mongoose, { Document, Schema } from "mongoose";
import MainModel from "../../../connect/mongoose.ts";

// Interface for TypeScript with PascalCase
export interface floorItenms extends Document {
  modeluuid: string;
  modelfileID: string;
  modelname: string;
  isLocked: boolean;
  isVisible: boolean;
  position: [];
  rotation: {
    x: number;
    y: number;
    z: number;
  };
}

// Define the Mongoose Schema
const floorItemsSchema: Schema = new Schema({
  modeluuid: { type: String },
  modelfileID: { type: String },
  modelname: { type: String },
  position: { type: Array },
  isLocked: { type: Boolean },
  isVisible: { type: Boolean },
  rotation: {
    x: { type: Number, required: true },
    y: { type: Number, required: true },
    z: { type: Number, required: true },
  },
});

// export default floorItemsModel;
const floorItemsModel = (db: string) => {
  return MainModel(db, "floorItems", floorItemsSchema, "floorItems");
};
export default floorItemsModel;
