import mongoose, { Document, Schema } from "mongoose";
import MainModel from "../../../connect/mongoose.ts";

// Interface for TypeScript with PascalCase
export interface Camera extends Document {
  userId: string;
  position: {
    x: number;
    y: number;
    z: number;
  };
  target: {
    x: { type: Number; required: true };
    y: { type: Number; required: true };
    z: { type: Number; required: true };
  };
  rotation: {
    x: { type: Number; required: true };
    y: { type: Number; required: true };
    z: { type: Number; required: true };
  };
}

// Define the Mongoose Schema
const cameraSchema: Schema = new Schema({
  userId: { type: String },
  position: {
    x: { type: Number, required: true },
    y: { type: Number, required: true },
    z: { type: Number, required: true },
  },
  target: {
    x: { type: Number, required: true },
    y: { type: Number, required: true },
    z: { type: Number, required: true },
  },
  rotation: {
    x: { type: Number, required: true },
    y: { type: Number, required: true },
    z: { type: Number, required: true },
  },
});

// export default cameraModel
const cameraModel = (db: string) => {
  return MainModel(db, "Camera", cameraSchema, "Camera");
};
export default cameraModel;
