import mongoose, { Schema, Document, model } from "mongoose";
import MainModel from "../../connect/mongoose.ts";

export interface Panel extends Document {
  panelOriginalOrder: string[];
  panelOrder: [
    {
      panelName: string;
      isArchive: boolean;
    }
  ];
  panelSide: string[];
  lockedPanel: string[];
  sceneID: string;
  zoneID: mongoose.Types.ObjectId;
  isArchive: boolean;
  createdBy: string;
  //   createdBy: mongoose.Types.ObjectId;
}
const panelSchema: Schema = new Schema(
  {
    panelOriginalOrder: {
      type: [String],
      enum: ["left", "right", "up", "down"],
    },
    panelOrder: [
      { panelName: String, isArchive: { type: Boolean, default: false } },
    ],
    panelSide: { type: [String], enum: ["left", "right", "up", "down"] },
    lockedPanel: { type: [String], enum: ["left", "right", "up", "down"] },
    sceneID: { type: String },
    zoneID: { type: mongoose.Schema.Types.ObjectId, ref: "Zone" },
    isArchive: { type: Boolean, default: false },
    createdBy: { type: String },
    // createdBy: { type: mongoose.Schema.Types.ObjectId, ref: "User" },
  },
  { timestamps: true }
);

const dataModel = (db: any) => {
  return MainModel(db, "Panel", panelSchema, "Panel");
};
export default dataModel;
